package cn.ibizlab.r7.runtime.service.runtimemgr.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.core.r7rt_base.valuerule.anno.unires.*;
import cn.ibizlab.r7.runtime.core.r7rt_base.domain.UniRes;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[UniResDTO]
 */
public class UniResDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @UniResUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [UNIRESNAME]
     *
     */
    @UniResUniResNameDefault(info = "默认规则")
    private String uniResName;

    @JsonIgnore
    private boolean uniResNameDirtyFlag;

    /**
     * 属性 [UNIRESID]
     *
     */
    @UniResUniResIdDefault(info = "默认规则")
    private String uniResId;

    @JsonIgnore
    private boolean uniResIdDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @UniResCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [ENABLE]
     *
     */
    @UniResEnableDefault(info = "默认规则")
    private Integer enable;

    @JsonIgnore
    private boolean enableDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @UniResCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @UniResUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [SYSTEMNAME]
     *
     */
    @UniResSystemNameDefault(info = "默认规则")
    private String systemName;

    @JsonIgnore
    private boolean systemNameDirtyFlag;

    /**
     * 属性 [SYSTEMID]
     *
     */
    @UniResSystemIdDefault(info = "默认规则")
    private String systemId;

    @JsonIgnore
    private boolean systemIdDirtyFlag;


    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [UNIRESNAME]
     */
    @JsonProperty("uniresname")
    public String getUniResName(){
        return uniResName ;
    }

    /**
     * 设置 [UNIRESNAME]
     */
    @JsonProperty("uniresname")
    public void setUniResName(String  uniResName){
        this.uniResName = uniResName ;
        this.uniResNameDirtyFlag = true ;
    }

    /**
     * 获取 [UNIRESNAME]脏标记
     */
    @JsonIgnore
    public boolean getUniResNameDirtyFlag(){
        return uniResNameDirtyFlag ;
    }

    /**
     * 获取 [UNIRESID]
     */
    @JsonProperty("uniresid")
    public String getUniResId(){
        return uniResId ;
    }

    /**
     * 设置 [UNIRESID]
     */
    @JsonProperty("uniresid")
    public void setUniResId(String  uniResId){
        this.uniResId = uniResId ;
        this.uniResIdDirtyFlag = true ;
    }

    /**
     * 获取 [UNIRESID]脏标记
     */
    @JsonIgnore
    public boolean getUniResIdDirtyFlag(){
        return uniResIdDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [ENABLE]
     */
    @JsonProperty("enable")
    public Integer getEnable(){
        return enable ;
    }

    /**
     * 设置 [ENABLE]
     */
    @JsonProperty("enable")
    public void setEnable(Integer  enable){
        this.enable = enable ;
        this.enableDirtyFlag = true ;
    }

    /**
     * 获取 [ENABLE]脏标记
     */
    @JsonIgnore
    public boolean getEnableDirtyFlag(){
        return enableDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [SYSTEMNAME]
     */
    @JsonProperty("systemname")
    public String getSystemName(){
        return systemName ;
    }

    /**
     * 设置 [SYSTEMNAME]
     */
    @JsonProperty("systemname")
    public void setSystemName(String  systemName){
        this.systemName = systemName ;
        this.systemNameDirtyFlag = true ;
    }

    /**
     * 获取 [SYSTEMNAME]脏标记
     */
    @JsonIgnore
    public boolean getSystemNameDirtyFlag(){
        return systemNameDirtyFlag ;
    }

    /**
     * 获取 [SYSTEMID]
     */
    @JsonProperty("systemid")
    public String getSystemId(){
        return systemId ;
    }

    /**
     * 设置 [SYSTEMID]
     */
    @JsonProperty("systemid")
    public void setSystemId(String  systemId){
        this.systemId = systemId ;
        this.systemIdDirtyFlag = true ;
    }

    /**
     * 获取 [SYSTEMID]脏标记
     */
    @JsonIgnore
    public boolean getSystemIdDirtyFlag(){
        return systemIdDirtyFlag ;
    }



    public UniRes toDO() {
        UniRes srfdomain = new UniRes();
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getUniResNameDirtyFlag())
            srfdomain.setUniResName(uniResName);
        if(getUniResIdDirtyFlag())
            srfdomain.setUniResId(uniResId);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getEnableDirtyFlag())
            srfdomain.setEnable(enable);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getSystemNameDirtyFlag())
            srfdomain.setSystemName(systemName);
        if(getSystemIdDirtyFlag())
            srfdomain.setSystemId(systemId);

        return srfdomain;
    }

    public void fromDO(UniRes srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getUniResNameDirtyFlag())
            this.setUniResName(srfdomain.getUniResName());
        if(srfdomain.getUniResIdDirtyFlag())
            this.setUniResId(srfdomain.getUniResId());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getEnableDirtyFlag())
            this.setEnable(srfdomain.getEnable());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getSystemNameDirtyFlag())
            this.setSystemName(srfdomain.getSystemName());
        if(srfdomain.getSystemIdDirtyFlag())
            this.setSystemId(srfdomain.getSystemId());

    }

    public List<UniResDTO> fromDOPage(List<UniRes> poPage)   {
        if(poPage == null)
            return null;
        List<UniResDTO> dtos=new ArrayList<UniResDTO>();
        for(UniRes domain : poPage) {
            UniResDTO dto = new UniResDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

